#ifndef DERIVEE_SPLINE_H
#define DERIVEE_SPLINE_H

/************************************************************************/
/*																		*/
/* Author			Philippe Thevenaz									*/
/* Affiliation		Ecole polytechnique federale de Lausanne			*/
/*					DMT/IOA/BIG											*/
/*					P.O. Box 127										*/
/*					CH-1015 Lausanne									*/
/*					Switzerland											*/
/* Telephone		+41(21)693.51.89									*/
/* Telefax			+41(21)693.37.01									*/
/* Email			philippe.thevenaz@epfl.ch							*/
/*																		*/
/************************************************************************/

/************************************************************************/
/* Public implementation follows										*/
/************************************************************************/

/*--- Defines ----------------------------------------------------------*/

#undef				FALSE
#define				FALSE			((int)(0 != 0))

#undef				TRUE
#define				TRUE			((int)(!FALSE))

#undef				ERROR
#define				ERROR			((int)TRUE)

/*--- Types ------------------------------------------------------------*/

struct	trsfStruct {
  double			dx[3];
  double			skew[3][3];
};

/*--- Functions --------------------------------------------------------*/
int			directBsplineMirror
									(float				*inPtr,
									 float				*outPtr,
									 long				nx,
									 long				ny,
									 long				nz,
									 int				degree);


int					gradX	(			 float				*inPtr,
									 float				*outPtr,
									 long				nx,
									 long				ny,
									 int				interpolationDegree,
									 float				background);
int					gradY	(			 float				*inPtr,
									 float				*outPtr,
									 long				nx,
									 long				ny,
									 int				interpolationDegree,
									 float				background);
int					derivYY	(			 float				*inPtr,
									 float				*outPtr,
									 long				nx,
									 long				ny,
									 int				interpolationDegree,
									 float				background);
int					derivXX	(			 float				*inPtr,
									 float				*outPtr,
									 long				nx,
									 long				ny,
									 int				interpolationDegree,
									 float				background);									 
int					derivXY	( 			 float				*splinePtr,
		 							 float				*outPtr,
		  							 long				nx,
									 long				ny,
		 							 int				interpolationDegree,
									 float				background) ;
void		errorReport		(char				*errorMessage);

#endif

